; kia.asm 
; gyors vltozat, 5 ponttal, 2,048 s 4,096 V bels referencival. A 2. OPA a 
; bemenetet ersti. 

	list		p=16f1704      ; list directive to define processor
	list		r=dec
	#include	<p16f1704.inc> ; processor specific variable definitions

; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF &  _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF 
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF &  _LVP_OFF

; Vltozk
	cblock 0x70
	ah
	al
	dh
	dl
	count
	flags
	munka1
	munka2
	endc

#define ms1	flags,0
#define msx flags,1
#define	kicsi	flags,2
#define	dmode	porta,3
  
; limitek (specilis tblzat)
lim4	equ	43251	; fltte tdik
lim3	equ	40339	; fltte negyedik
lim2	equ	38278	; fltte harmadik
lim1	equ	36090	; fltte msodik
lim0	equ	34860	; fltte els

; lim5 a csillagos g!

; vlasztk
selmea	equ	99h	; an6
refmea	equ	13h

#include prlx.inc	

	org     0x0000             
	pagesel start
	goto    start             
  
	org      0x0004
	banksel	porta
	bcf	pir1,tmr2if
	bcf	pir1,adif
	bsf	ms1	;1 ms marker
	decfsz	munka2,f
	retfie
	movlw	30
	movwf	munka2
	bsf	flags,1	; 30 ms marker
	retfie

start
	banksel	ansela
	clrf	ansela
	movlw   1ch
	movwf   anselc
	banksel	porta
	movlw   7
	movwf	porta	; kiolts a-n		
	movwf	portc
	clrf	pir1
	movlw	249	; timer2 peridus
	movwf	pr2
	movlw	1
	movwf	t2con	; 4 pre, a 250-nel egytt 1 ms idzts, mg ll
	banksel	wpua
	movlw	8
	movwf	wpua
	clrf	wpuc
	banksel	opa2con
	movlw	0c3h	; egyenirnythoz a frgbbet!
	movwf	opa2con
	banksel	fvrcon
	movlw	8bh
	movwf	fvrcon	
	banksel	trisa
	movlw	8
	movwf	option_reg
	movlw	0x68		; 4 MHz, 8-ra emelhet, maradhat
	movwf	osccon
	bsf	pie1,tmr2ie	; ez lesz az egyetlen engedlyezett megszakts
	movlw	8		; csak ra3 bemenet, mert muszj
	movwf	trisa
	movlw   1ch
	movwf	trisc		; RC0, 1, 5 kimenet, 2, 3, 4 bemenet
	banksel	porta
	clrf	munka2
	incf	munka2,f	; els dekrementnl megszakt majd
	banksel	porta
	bsf	intcon,peie
	bsf	intcon,gie	; ezzel beengedem a tmr2 megszaktst (s semmi mst)
	bsf	t2con,tmr2on	; van megszakts, ra indul
	banksel	adcon0
	movlw	selmea
	movwf	adcon0
	movlw	refmea
	movwf	adcon1
	banksel	porta
	movlw	5
	movwf	count
knr0
	btfss	flags,1
	goto	knr0
	bcf	flags,1
	movf	count,w
	sublw	7
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr0
	movlw	5
	movwf	count
knr1
	btfss	flags,1
	goto	knr1
	bcf	flags,1
	incf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr1
	movlw	5
	movwf	count
knr2
	btfss	flags,1
	goto	knr2
	bcf	flags,1
	movf	count,w
	sublw	7
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr2
	movlw	5
	movwf	count
knr3
	btfss	flags,1
	goto	knr3
	bcf	flags,1
	incf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr3
main
conv10				; itt vr j konverzira
	btfss	ms1
	goto	conv10		; 
	bcf	ms1
	banksel	adcon0		; a go bit ott van
	bsf	adcon0,go
	nop
adwait				; megvrja a konverzi vgt
	btfsc	adcon0,go
	goto	adwait
	movf	adresh,w
	movwf	ah
	movf	adresl,w
	movwf	al
	call	range
	call	allit
	goto	main
	
; a range szubrutin a fejlcben definilt konstansokkal sszehasonltva
; generlja a tartomny 0-tl 6-ig terjed sorszmt. Nem gazdasgos,
; de rrnk. Az els g a kettes! Tlcsordulst nem kell figyelni.	
range
	clrf	dl
	movf	ah,w
	iorwf	al,w
	snz
	return
	incf	dl,f	; (1) ez mg kioltott
	csael	ah,high lim0
	return		; mert mr ah kisebb
	cjal	ah,high lim0,rng1
	csal	al,low lim0
	return		; mert ah egyenl, de al nem nagyobb
rng1
	incf	dl,f
	csael	ah,high lim1
	return		
	cjal	ah,high lim1,rng2
	csal	al,low lim1
	return
rng2
	incf	dl,f
	csael	ah,high lim2
	return		
	cjal	ah,high lim2,rng3
	csal	al,low lim2
	return
rng3
	incf	dl,f
	csael	ah,high lim3
	return		
	cjal	ah,high lim3,rng4
	csal	al,low lim3
	return
rng4
	incf	dl,f	; (5) ez a negyedik
	csael	ah,high lim4
	return		
	cjal	ah,high lim4,rng5
	csal	al,low lim4
	return
rng5
	incf	dl,f	; (6) ez a legfels
	return

allit
	banksel	porta
	pagesel nbara
	movf	dl,w
	addlw	low nbara
	callw
	comf	wreg,f
	movwf	porta
	movf	dl,w
	addlw	low nbarc
	callw
	comf	wreg,f
	movwf	portc
	movlp	0
	return

	ORG	0X200
nbara
	dt	0, 0, 0, 0, 4, 6, 7, 7

nbarc
	dt	0, 0, 2, 3, 3, 3, 3, 3

    END