; piclmvu.asm 
; norml lbelrendezs gyors vltozat, 10 ponttal, a fels tartomny
; nylt. A gyors programok mind balra igaztanak. Sv- s pontkijelzs,

	list		p=16f1707      ; list directive to define processor
	list		r=dec
	#include	<p16f1707.inc> ; processor specific variable definitions

; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF &  _BOREN_OFF & _CLKOUTEN_OFF 
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF &  _LVP_OFF

; Vltozk
    	cblock 0x70 ; define gpr variable register locations
    	ah
    	al
    	dh
    	dl
    	count
    	flags
    	munka2
    	endc
#define ms1	flags,0
#define msx 	flags,1
#define	kicsi	flags,2
#define magas   flags,3
#define	dmode	porta,3
#define lowsel  rb5pps  
; limitek (VU skla)
lim0	equ	4131
lim1	equ	13063
lim2	equ	18452
lim3	equ	23230
lim4	equ	29245
lim5	equ	36817
lim6	equ	41310
lim7	equ	46350
lim8	equ	52006
lim9	equ	58352
; lim10 a csillagos g (a skla vge mg 1 dB)!

; vlasztk
selmea	equ	9	; ra2=an2
refmea	equ	16h
selbri	equ	11h	; rc0=an4
refbri	equ	10h

#include prlx.inc	

    	org     0x0000            ; 
    	pagesel start
    	goto    start             
  
    	org      0x0004
	banksel	porta
	bcf	pir1,tmr2if
	bsf	ms1	;1 ms marker
	decfsz	munka2,f
	retfie
	movlw	30
	movwf	munka2
	bsf	msx	; 30 ms marker
	retfie

start
	banksel	ansela
	movlw	7	; 1 bemenet, 2 referencia
	movwf	ansela
    	movlw   10h ; az opa egyik lba
    	movwf   anselb
    	movlw   5   ; egy bemenet, egy OPA lb
    	movwf   anselc
	banksel	porta
    	movlw   38h
	movwf	porta	; kiolts a-n		
	movlw	0ffh	; mindent kiolt sz
	movwf	portb
	movwf	portc
	clrf	pir1
	movlw	249	; timer2 peridus
	movwf	pr2
	movlw	1
	movwf	t2con	; 4 pre, a 250-nel egytt 1 ms idzts, mg ll
	banksel	wpua
	movlw	8
	movwf	wpua
	clrf	wpub
	clrf	wpuc
	banksel	opa1con
	movlw	0c3h
	movwf	opa1con
	banksel	fvrcon
	movlw	85h
	movwf	fvrcon	
    	banksel rc1pps
    	movlw   0dh
    	movwf   rc1pps
	banksel	trisa
	movlw	8
	movwf	option_reg
	movlw	0x68		; 4 mhz, 8-ra emelhet  maradhat
	movwf	osccon
	bsf pie1,tmr2ie	; ez lesz az egyetlen engedlyezett megszakts
	movlw	0x0f		; ra4,5 kimenet
	movwf	trisa
    	movlw   10h
    	movwf   trisb
    	movlw   1
	movwf	trisc		; a tbbi kimenet
	banksel	ccp1con
	movlw	0ch
	movwf	ccp2con
		movlw	249
		movwf	ccpr1l
    	movlw   3ch
    	movwf   ccp1con ; be van kapcsolva, 1 ezrelk, de nincs kimenete!
	banksel	porta
	clrf	munka2
	incf	munka2,f	; els dekrementnl megszakt majd
	bsf	intcon,peie
	bsf	intcon,gie	; ezzel beengedem a tmr2 megszaktst (s semmi mst)
	bsf	t2con,tmr2on	; van megszakts, ra indul
	movlw	127
	banksel	ccpr2l
	movwf	ccpr2l
	banksel	adcon0
	movlw	selmea
	movwf	adcon0
    	movlw   refmea
    	movwf   adcon1
	banksel	porta
knrlp
	movlw	10
	movwf	count
knr0
	btfss	msx
	goto	knr0
	bcf	msx
	movf	count,w
	sublw	11
	movwf	dl
	call	allit
    	bcf 	portb,7
	decfsz	count,f
	goto	knr0
	movlw	10
	movwf	count
knr1
	btfss	msx
	goto	knr1
	bcf	msx
	movf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr1
	movlw	10
	movwf	count
knr2
	btfss	msx
	goto	knr2
	bcf	msx
	movf	count,w
	sublw	11
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr2
	movlw	10
	movwf	count
knr3
	btfss	msx
	goto	knr3
	bcf	msx
	movf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr3
	bsf	flags,1
main
	btfsc	msx
	call	fenyero
conv10				; itt vr j konverzira
	btfss	ms1
	goto	conv10		; 
	bcf	ms1
	banksel	adcon0		; a go bit ott van
	bsf	adcon0,go
	nop
adwait				; megvrja a konverzi vgt
	btfsc	adcon0,go
	goto	adwait
	movf	adresh,w
	movwf	ah
	movf	adresl,w
	movwf	al
	call	range
	call	allit
	goto	main
	
allit
	banksel	porta
;	movlw	255
;    	movwf   porta
;	movwf	portb	; mind kiolt
;    	movlw   0fdh
;	movwf	portc
	movlp   high ndota
	movf	dl,w	; ott volt a sorszm
	sb	dmode
	addlw	low ndota	; tkrhz tdota
	snb	dmode
	addlw	low nbara
	callw
	comf	wreg,f
	movwf	porta
	movf	dl,w
	sb	dmode
	addlw	low ndotb	; tkrhz tdotb
	snb	dmode
	addlw	low nbarb
	callw
	comf	wreg,f
	movwf	portb
	movf	dl,w
	sb	dmode
	addlw	low ndotc	; tkrhz tdotc
	snb	dmode
	addlw	low nbarc
	callw
	comf	wreg,f
	movwf	portc
	movlp	0
    	movlw	12		; innen a kiolt impulzus, ha kell:
; nincs kiolt, ha dmode=1 (sv), vagy magas=0 (portvezrls van)
	sb		dmode
	sb		magas
	movlw	0
	banksel	lowsel
	movwf	lowsel
	banksel	0
    return

; a range szubrutin a fejlcben definilt konstansokkal sszehasonltva
; generlja a tartomny 0-tl 11-ig terjed sorszmt. Nem gazdasgos,
; de rrnk. A vegyes kijelzs miatt mg kt llapotot kell felismernie:
; a nullt s az 1023-at. Ezek miatt a tblzatai is hosszabbak, 12 
; llapothoz tartalmaznak maszkot. Az els g az egyes! Az llapotvl-
; tozs figyelse miatt nem lehet azonos a kt kioltott llapot. Kapott 
; egy magas nev? flaget is a kiolts tmogatsra.	
range
	clrf	dl
    	bcf 	magas
	movf	ah,w
	iorwf	al,w
	snz
	return
	incf	dl,f
	csael	ah,high lim0
	return		; mert mr ah kisebb
	cjal	ah,high lim0,rng1
	csal	al,low lim0
	return		; mert ah egyenl, de al nem nagyobb
rng1
	incf	dl,f
;    	bsf magas
    	sb  dmode
	csael	ah,high lim1
	return		
	cjal	ah,high lim1,rng2
	csal	al,low lim1
	return
rng2
	incf	dl,f
    	bsf magas  ; linerisnl rng1-ben!
	csael	ah,high lim2
	return		
	cjal	ah,high lim2,rng3
	csal	al,low lim2
	return
rng3
	incf	dl,f
	csael	ah,high lim3
	return		
	cjal	ah,high lim3,rng4
	csal	al,low lim3
	return
rng4
	incf	dl,f
	csael	ah,high lim4
	return		
	cjal	ah,high lim4,rng5
	csal	al,low lim4
	return
rng5
	incf	dl,f
	csael	ah,high lim5
	return		
	cjal	ah,high lim5,rng6
	csal	al,low lim5
	return
rng6
	incf	dl,f
	csael	ah,high lim6
	return		
	cjal	ah,high lim6,rng7
	csal	al,low lim6
	return
rng7
	incf	dl,f
	csael	ah,high lim7
	return	
	cjal	ah,high lim7,rng8
	csal	al,low lim7
	return
rng8
	incf	dl,f
	csael	ah,high lim8
	return	
	cjal	ah,high lim8,rng9
	csal	al,low lim8
	return
rng9
	incf	dl,f
	csael	ah,high lim9
	return	
	cjal	ah,high lim9,rng10
	csal	al,low lim9
	return
rng10
	incf	dl,f
	csel	ah,0ffh
	return
	csael	al,0c0h
	return
	snb	kicsi	; tiltott range csak ha nem kicsi
	incf	dl,f
	return
; az tdolgozott fnyer szubrutin a 20%-tl 100%-ig terjed rszt
; nagytja a teljes tartomnyra, mikzben 20% alatt kicsi = 1. gy
; elg 1 V-ig lehzni a fnyer bemenetet a kioltshoz.
fenyero
	bcf	msx	
	banksel	adcon0
	movlw	selbri
	movwf	adcon0
	movlw	refbri
	movwf	adcon1
	nop
	bsf	adcon0,go
briwt
	btfsc	adcon0,go
	goto	briwt
	movf	adresh,w
	movwf	dh
	bsf	kicsi
	cjbl	dh,55,skkicsi
	bcf	kicsi
    	movlw   55
    	subwf   dh,f
    	movf    dh,w
    	clc
    	rrf 	dh,f
    	clc
    	rrf 	dh,f
    	addwfc 	dh,f
    	snb 	kicsi
    	clrf    dh
skkicsi
	comf	dh,w
	banksel	ccpr2l
	movwf	ccpr2l
	banksel	adcon0	; az igazi itt folytatdik
	movlw	selmea
	movwf	adcon0
	movlw	refmea
	movwf	adcon1
	banksel	porta
	return
; a kitlt szubrutin beolvadt a fnyerbe (kt helyen van fnyer!)!

	ORG	0X200
#include    <tables.inc>
    	END