; uaa180n.asm (br fejleszts kzben nem az a neve)                                             

; norml lbelrendezs gyors vltozat, 12 ponttal, a fels tartomny
; nylt. A gyors programok mind balra igaztanak. Sv- s pontkijelzs,
; jumperes vltssal. Svkijelzsnl max. 50% kitlts. 

	list		p=16f1828      ; list directive to define processor
	list		r=dec
	#include	<p16f1828.inc> ; processor specific variable definitions


; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF

; Vltozk
    	cblock 0x70 ; define gpr variable register locations
    	ah
    	al
    	dh
    	dl
    	count
    	flags
    	munka2
    	endc
#define ms1	flags,0
#define	kicsi	flags,2
#define	dmode	porta,3  
; limitek (mostantl felsk)
lim0	equ	5456
lim1	equ	10912
lim2	equ	16368
lim3	equ	21824
lim4	equ	27280
lim5	equ	32736
lim6	equ	38192
lim7	equ	43648
lim8	equ	49104
lim9	equ	54560
lim10	equ	60016
; lim11 a csillagos g!

; vlasztk
selmea	equ	9	; ra2=an2
refmea	equ	16h
selbri	equ	0dh	; ra4=an3
refbri	equ	10h

#include prlx.inc	

    	org     0x0000            ; 
    	pagesel start
    	goto    start             
  
    	org     0x0004
	banksel	porta
	bcf	pir1,tmr2if
	bcf	pir1,adif
	bsf	ms1	;1 ms marker
	decfsz	munka2,f
	retfie
	movlw	30
	movwf	munka2
	bsf	flags,1	; 30 ms marker
	retfie

start
	banksel	ansela
	movlw	17h	; 2 bemenet, 2 referencia, 1 alibi
	movwf	ansela
	banksel	porta
	clrf	porta	; max. fnyer lenne		
	movlw	0ffh	; kiolt sz
	movwf	portb
	movwf	portc
	clrf	pir1
	movlw	249	; timer2 peridus
	movwf	pr2
	movlw	1
	movwf	t2con	; 4 pre, a 250-nel egytt 1 ms idzts, mg ll
	banksel	wpua
	movlw	8
	movwf	wpua
	clrf	wpub
	clrf	wpuc	
	banksel	trisa
	movlw	8
	movwf	option_reg
	movlw	0x68		; 4 mhz, 8-ra emelhet  maradhat
	movwf	osccon
	bsf	pie1,tmr2ie	; ez lesz az egyetlen engedlyezett megszakts
	movlw	0xdf		; ra5 kimenet
	movwf	trisa
	clrf	trisb
	clrf	trisc		; mind kimenet
	banksel	apfcon1
	bsf	apfcon1,0
	banksel	porta
	clrf	munka2
	incf	munka2,f	; els dekrementnl megszakt majd
	banksel	ccp2con
	movlw	0ch
	movwf	ccp2con
	banksel	porta
	bsf	intcon,peie
	bsf	intcon,gie	; ezzel beengedem a tmr2 megszaktst (s semmi mst)
	bsf	t2con,tmr2on	; van megszakts, ra indul
	movlw	127
	banksel	ccpr2l
	movwf	ccpr2l
	banksel	adcon0
	movlw	selmea
	movwf	adcon0
	banksel	porta
	movlw	12
	movwf	count
knr0
	btfss	flags,1
	goto	knr0
	bcf	flags,1
	movf	count,w
	sublw	13
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr0
	movlw	12
	movwf	count
knr1
	btfss	flags,1
	goto	knr1
	bcf	flags,1
	movf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr1
	movlw	12
	movwf	count
knr2
	btfss	flags,1
	goto	knr2
	bcf	flags,1
	movf	count,w
	sublw	13
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr2
	movlw	12
	movwf	count
knr3
	btfss	flags,1
	goto	knr3
	bcf	flags,1
	movf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr3
	bsf	flags,1
main
	btfsc	flags,1
	call	fenyero
conv10				; itt vr j konverzira
	btfss	ms1
	goto	conv10		; 
	bcf	ms1
	banksel	adcon0		; a go bit ott van
	bsf	adcon0,go
	nop
adwait				; megvrja a konverzi vgt
	btfsc	adcon0,go
	goto	adwait
	movf	adresh,w
	movwf	ah
	movf	adresl,w
	movwf	al
	banksel	porta
	call	range
	call	allit
	goto	main
	
allit
	banksel	porta
	movlp	high ndotb
	movf	dl,w	; ott volt a sorszm
	sb	dmode
	addlw	low ndotb	; tkrhz tukorb
	snb	dmode
	addlw	low nbarb
	callw
	comf	wreg,f
	movwf	portb
	movf	dl,w
	sb	dmode
	addlw	low ndotc	; tkrhz tukorb
	snb	dmode
	addlw	low nbarc
	callw
	comf	wreg,f
	movwf	portc
	movlp	0
	return
; a range szubrutin a fejlcben definilt konstansokkal sszehasonltva
; generlja a tartomny 0-tl 11-ig terjed sorszmt. Nem gazdasgos,
; de rrnk. A vegyes kijelzs miatt mg kt llapotot kell felismernie:
; a nullt s az 1023-at. Ezek miatt a tblzatai is hosszabbak, 14 
; llapothoz tartalmaznak maszkot. Az els g az egyes! Az llapotvl-
; tozs figyelse miatt nem lehet azonos a kt kioltott llapot.	
range
	clrf	dl
	movf	ah,w
	iorwf	al,w
	snz
	return
	incf	dl,f	; (1)
	csael	ah,high lim0
	return		; mert mr ah kisebb
	cjal	ah,high lim0,rng1
	csal	al,low lim0
	return		; mert ah egyenl, de al nem nagyobb
rng1
	incf	dl,f
	csael	ah,high lim1
	return		
	cjal	ah,high lim1,rng2
	csal	al,low lim1
	return
rng2
	incf	dl,f
	csael	ah,high lim2
	return		
	cjal	ah,high lim2,rng3
	csal	al,low lim2
	return
rng3
	incf	dl,f
	csael	ah,high lim3
	return		
	cjal	ah,high lim3,rng4
	csal	al,low lim3
	return
rng4
	incf	dl,f
	csael	ah,high lim4
	return		
	cjal	ah,high lim4,rng5
	csal	al,low lim4
	return
rng5
	incf	dl,f
	csael	ah,high lim5
	return		
	cjal	ah,high lim5,rng6
	csal	al,low lim5
	return
rng6
	incf	dl,f
	csael	ah,high lim6
	return		
	cjal	ah,high lim6,rng7
	csal	al,low lim6
	return
rng7
	incf	dl,f
	csael	ah,high lim7
	return	
	cjal	ah,high lim7,rng8
	csal	al,low lim7
	return
rng8
	incf	dl,f
	csael	ah,high lim8
	return	
	cjal	ah,high lim8,rng9
	csal	al,low lim8
	return
rng9
	incf	dl,f
	csael	ah,high lim9
	return	
	cjal	ah,high lim9,rng10
	csal	al,low lim9
	return
rng10
	incf	dl,f
	csael	ah,high lim10
	return	
	cjal	ah,high lim10,rng11
	csal	al,low lim10
rng11
	incf	dl,f		; (12)
	csel	ah,0ffh
	return
	csael	al,080h
	return
	snb	kicsi
	incf	dl,f		; (13)
	return

fenyero
	bcf	flags,1	; fnyer jn, ell-htul bemenetvlasztssal
	banksel	adcon0
	movlw	selbri
	movwf	adcon0
	movlw	refbri
	movwf	adcon1
	nop
	bsf	adcon0,go
briwt
	btfsc	adcon0,go
	goto	briwt
	movf	adresh,w
	movwf	dh
	clc
	snb	dmode
	rrf	dh,f
	bcf	kicsi
	csal	dh,8
	bsf	kicsi
	comf	dh,w
	banksel	ccpr2l
	movwf	ccpr2l
; a demo programnak van itt egy 3 soros bettje, ami flfnyre emel,
; ha elrem a kioltsi hatrt, gy egy tagon is megfigyelhet a 
; a kaszkdols hatsa 
	movlw	127
	snb	kicsi
	movwf	ccpr2l
	banksel	adcon0	; az igazi itt folytatdik
	movlw	selmea
	movwf	adcon0
	movlw	refmea
	movwf	adcon1
	banksel	porta
	return
; a kitlt szubrutin beolvadt a fnyerbe (kt helyen van fnyer!)!

; tblzatok a ktfle sorrendhez s a ktfle mdhoz
; n=norml, t=tkr, bar=bar, dot=dot, a maradk a port
	ORG	0X200
ndotb
	dt	0, 0, 0, 0, 10h, 20h, 40h, 80h
	dt	0, 0, 0, 0, 0, 0
nbarb
	dt	0, 0, 0, 0, 10h, 30h, 70h, 0f0h
	dt	0f0h, 0f0h, 0f0h, 0f0h, 0f0h, 0f0h
ndotc
	dt	0, 1, 2, 4, 0, 0, 0, 0
	dt	80h, 40h, 8, 10h, 20h, 0
nbarc
	dt	0, 1, 3, 7, 7, 7, 7, 7
	dt	87h, 0c7h, 0cfh, 0dfh, 0ffh, 0ffh
tdotb
	dt	0, 0, 0, 0, 0, 0, 80h, 40h
	dt	20h, 10h, 0, 0, 0, 0
tbarb
	dt	0, 0, 0, 0, 0, 0, 80h, 0c0h
	dt	0e0h, 0f0h, 0f0h, 0f0h, 0f0h, 0f0h
tdotc
	dt	0, 20h, 10h, 8, 40h, 80h, 0, 0
	dt	0, 0, 4, 2, 1, 0
tbarc
	dt	0, 020h, 30h, 38h, 78h, 0f8h, 0f8h, 0f8h
	dt	0f8h, 0f8h, 0fch, 0feh, 0ffh, 0ffh, 0ffh,0ffh
  
    END