;    uaa170n.asm (br fejleszts kzben nem az a neve)                                             

;    Norml lbelrendezs gyors vltozat, 16 ponttal, a szlsrtkek 
;    figyelsvel, ha szksges. 
;    Mintavtel s frissts 1 ms-onknt, fnyer llts 30 ms-onknt.
;    A frissts kioltssal jr, de csak akkor van frissts, ha az adat
;    vltozott.

	list		p=16f1827      
	list		r=dec
	#include	<p16f1827.inc> 

; Konfigurci (2 sz)
    __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_ON & _MCLRE_OFF & _CP_OFF & _CPD_OFF & _BOREN_OFF & _CLKOUTEN_OFF & _IESO_OFF & _FCMEN_OFF
    __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_19 & _LVP_OFF

; Vltozk egyszer mintavteli smhoz
    	cblock 0x70 ; mind lthat mindenhonnan
    	ah
    	al
    	dh
    	dl
    	count
    	flags
    	munka1
    	munka2
    	endc
#define ms1	flags,0
#define	ms30	flags,1  
; limitek: alattuk a sorszmuk rvnyes, a felsnek nincs hatra
; kivve ha a jumperek mst mondanak. (RA3 fels, RA4 als)
lim0	equ	4092
lim1	equ	8184
lim2	equ	12276
lim3	equ	16368
lim4	equ	20460
lim5	equ	24552
lim6	equ	28644
lim7	equ	32736
lim8	equ	36828
lim9	equ	40920
lim10	equ	45012
lim11	equ	49104
lim12	equ	53196
lim13	equ	57288
lim14	equ	61380
; vlasztk
selmea	equ	1	; ra0=an0
refmea	equ	16h
refmej	equ	13h	
selbri	equ	5	; ra1=an1
refbri	equ	10h
; jumperek
#define also	porta,7
#define felso	porta,6

#include prlx.inc	

	org     0x0000            ; 
	pagesel start
	goto    start             
  
	org	0x0004
	banksel	porta
	bcf	pir1,tmr2if
	bcf	pir1,adif
	bsf	ms1	;1 ms marker
	decfsz	munka2,f
	retfie
	movlw	30
	movwf	munka2
	bsf	ms30	; 30 ms marker
	retfie

start
	banksel	ansela
	movlw	1fh		; 2 bemenet, 2 referencia, 1 alibi
	movwf	ansela
	banksel	porta
	clrf	porta
	movlw	1eh		; b port is kioltva
	movwf	portb
	clrf	pir1
	movlw	249		; timer2 peridus
	movwf	pr2
	movlw	1
	movwf	t2con		; 4-es eloszt, a 250-nel egytt 1 ms idzts, mg ll
	banksel	wpua
	movlw	0e0h
	movwf	wpua
	movlw	1
	movwf	wpub	
	banksel	trisa
	movlw	8
	movwf	option_reg
	movlw	0x68		; 4 mhz, 8-ra emelhet  maradhat
	movwf	osccon
	bsf	pie1,tmr2ie	; ez lesz az egyetlen engedlyezett megszakts
	movlw	0xff		; alapban mind bemenet
	movwf	trisa
	movwf	trisb		; alapban mind bemenet
	banksel	apfcon0
	movlw	1
	movwf	apfcon0
	banksel	fvrcon
	movlw	82h
	movwf	fvrcon
	banksel	porta
	clrf	munka2
	incf	munka2,f	; els dekrementnl megszakt majd
	call	pwmini	
	bsf	intcon,peie
	bsf	intcon,gie	; ezzel beengedem a tmr2 megszaktst (s semmi mst)
	bsf	t2con,tmr2on	; van megszakts, ra indul
	movlw	16
	movwf	count
	movlw	255
	call	kitolt
; LED teszt
knr0
	btfss	ms30
	goto	knr0
	bcf	ms30
	movf	count,w
	sublw	17
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr0
	movlw	16
	movwf	count
knr1
	btfss	ms30
	goto	knr1
	bcf	ms30
	movf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr1
	movlw	16
	movwf	count
knr2
	btfss	ms30
	goto	knr2
	bcf	ms30
	movf	count,w
	sublw	17
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr2
	movlw	16
	movwf	count
knr3
	btfss	ms30
	goto	knr3
	bcf	ms30
	movf	count,w
	movwf	dl
	call	allit
	decfsz	count,f
	goto	knr3
	movlw	20
	movwf	munka1	; ezzel biztosan nem egyezik meg brmilyen dl!		
	bsf	ms30	; hogy fnyerlltssal induljon
main
	btfsc	ms30
	call	fenyero
	
conv10				; itt vr indulsra a konverzis ciklus
	btfss	ms1
	goto	conv10		; 
	bcf	ms1
	banksel	adcon0		; a go bit ott van
	bsf	adcon0,go
	nop
adwait				; megvrja a konverzi vgt
	btfsc	adcon0,go
	goto	adwait
	movf	adresh,w
	movwf	ah
	movf	adresl,w
	movwf	al
	banksel	porta
	call	range		; osztlyoz
	call	allit		; kir, ha az adat frisslt.
	goto	main
	
allit
	csne	dl,munka1
	return			; visszatr, ha az adat mg a rgi
	movf	dl,w
	movwf	munka1		; rgi=aktulis
	banksel	trisa
	movlw	0ffh
	movwf	trisa
	movwf	trisb		; ki kell oltani, hogy ne legyen tkzs
	movlp	high normala
	movf	dl,w	; ott volt a sorszm
	movwf	munka1	; aktulis rtk mentse
	addlw	low normala	; tkrhz nem kell
	callw			; tkrhz nem kell
	comf	wreg,f		; tkrhz nem kell
	movwf	trisa	; de elg ezt a sort kihagyni a tkrhz
	movf	dl,w
	addlw	low normalb	; tkrhz tukorb
	callw
	comf	wreg,f
	movwf	trisb
	movlp	0
	return
; a range szubrutin a fejlcben definilt konstansokkal sszehasonltva
; generlja a tartomny 0-tl 17-ig terjed sorszmt. Nulla csak akkor
; lehetsges, ha az als jumper, 17 csak ha a fels jumper fel van rakva.
; Ezek kiolt kdhoz vannak rendelve.
range
	clrf	dl
	jb	also,nemnul
	movf	ah,w
	iorwf	al,w
	snz
	return
nemnul
	incf	dl,f	; (1) nulltl egyig, 1. LED
	csael	ah,high lim0
	return		; mert mr ah kisebb
	cjal	ah,high lim0,rng1
	csal	al,low lim0
	return		; mert ah egyenl, de al nem nagyobb
rng1
	incf	dl,f	;(2)
	csael	ah,high lim1
	return		
	cjal	ah,high lim1,rng2
	csal	al,low lim1
	return
rng2
	incf	dl,f
	csael	ah,high lim2
	return		
	cjal	ah,high lim2,rng3
	csal	al,low lim2
	return
rng3
	incf	dl,f
	csael	ah,high lim3
	return		
	cjal	ah,high lim3,rng4
	csal	al,low lim3
	return
rng4
	incf	dl,f
	csael	ah,high lim4
	return		
	cjal	ah,high lim4,rng5
	csal	al,low lim4
	return
rng5
	incf	dl,f
	csael	ah,high lim5
	return		
	cjal	ah,high lim5,rng6
	csal	al,low lim5
	return
rng6
	incf	dl,f
	csael	ah,high lim6
	return		
	cjal	ah,high lim6,rng7
	csal	al,low lim6
	return
rng7
	incf	dl,f
	csael	ah,high lim7
	return	
	cjal	ah,high lim7,rng8
	csal	al,low lim7
	return
rng8
	incf	dl,f
	csael	ah,high lim8
	return	
	cjal	ah,high lim8,rng9
	csal	al,low lim8
	return
rng9
	incf	dl,f
	csael	ah,high lim9
	return	
	cjal	ah,high lim9,rng10
	csal	al,low lim9
	return
rng10
	incf	dl,f
	csael	ah,high lim10
	return	
	cjal	ah,high lim10,rng11
	csal	al,low lim10
	return
rng11
	incf	dl,f
	csael	ah,high lim11
	return	
	cjal	ah,high lim11,rng12
	csal	al,low lim11
	return
rng12
	incf	dl,f
	csael	ah,high lim12
	return	
	cjal	ah,high lim12,rng13
	csal	al,low lim12
	return
rng13
	incf	dl,f
	csael	ah,high lim13
	return	
	cjal	ah,high lim13,rng14
	csal	al,low lim13
	return
rng14
	incf	dl,f	; (15)
	csael	ah,high lim14
	return	
	cjal	ah,high lim14,rng15
	csal	al,low lim14
	return
rng15
	incf	dl,f	; (16)
	csel	ah,0ffh
	return
	csael	al,080h
	return
	sb	felso
	incf	dl,f	; (17)
	return
	
pwmini
	banksel	ccp1con
	movlw	0ch
	movwf	ccp1con
;	movlw	3		; P1B tilos a normlnak!
;	movwf	pstr1con	; ez a kt sor kell a tkrnek
	movlw	0ch
	movwf	ccp2con
	movlw	3
	movwf	pstr2con
	banksel	ccp4con		; ez tilos a tkrnek
	movlw	0ch
	movwf	ccp4con
	banksel	porta
	return

fenyero
	bcf	ms30	; fnyer jn, ell-htul bemenetvlasztssal
	banksel	adcon0
	movlw	selbri
	movwf	adcon0
	movlw	refbri
	movwf	adcon1
	nop
	bsf	adcon0,go
briwt
	btfsc	adcon0,go
	goto	briwt
	call	kitolt
	banksel	adcon0
	movlw	selmea
	movwf	adcon0
	banksel	porta
	movlw	refmea
	sb	porta,5
	movlw	refmej
	banksel	adcon0
	movwf	adcon1
	return

; az sszes helyre berja a kitltst, abbl nem lehet baj
kitolt
	movf	adresh,w
	banksel	ccpr1l
	movwf	ccpr1l
	movwf	ccpr2l
	banksel	ccpr3l
	movwf	ccpr3l
	movwf	ccpr4l
	banksel	porta
	return
; tblzatok a ktfle sorrendhez
	ORG	0X200
normala
	dt	0, 0, 0, 0, 0, 0, 0, 0, 0
	dt	0, 0, 0, 0, 16, 16, 16, 16, 0
normalb
	dt	0, 11h, 9, 5, 3, 42h, 44h, 48h, 50h
	dt	90h, 88h, 84h, 82h, 2, 4, 8, 16, 0
tukorb
	dt	0, 42h, 44h, 48h, 50h, 30h, 28h, 24h, 22h
	dt	82h, 84h, 88h, 90h, 11h, 9, 5, 3, 0  
    END